//------------------------------------------------------------------
// as described by M.H.Pee
// December 2004 TASC article "Trend trigger Factor"
//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 LightSeaGreen
#property indicator_color2 DimGray
#property indicator_color3 LimeGreen
#property indicator_color4 PaleVioletRed
#property indicator_width3 1
#property indicator_width4 1
#property indicator_level1 0.0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int    TTFbars    =  15;
extern int    TopLine    =  75;
extern int    BottomLine = -75;

//
//
//
//
//

double MainBuffer[];
double SignalBufferUp[];
double SignalBufferDn[];
double SignalBuffer[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   SetIndexBuffer(0, MainBuffer);     SetIndexLabel(0,"TTF");
   SetIndexBuffer(1, SignalBuffer);   SetIndexLabel(1,"Signal");
   SetIndexBuffer(2, SignalBufferUp); SetIndexLabel(2,"SignalUp");   SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3, SignalBufferDn); SetIndexLabel(3,"SignalDown"); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
   IndicatorShortName("Trend Trigger Factor ("+TTFbars+")");
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(i=limit; i>=0; i--)
      {
         double HighestHighRecent= High[iHighest(NULL,0,MODE_HIGH,TTFbars,i)];
         double HighestHighOlder = High[iHighest(NULL,0,MODE_HIGH,TTFbars,i+TTFbars)];
         double LowestLowRecent  = Low[iLowest(NULL,0,MODE_LOW,TTFbars,i)];
         double LowestLowOlder   = Low[iLowest(NULL,0,MODE_LOW,TTFbars,i+TTFbars)];
         double BuyPower         = HighestHighRecent-LowestLowOlder;
         double SellPower        = HighestHighOlder -LowestLowRecent;
  
      //
      //
      //
      //
      //
      
      MainBuffer[i] = (BuyPower-SellPower)/(0.5*(BuyPower+SellPower))*100;
      if (MainBuffer[i]>=0) 
               SignalBuffer[i]=TopLine;
      else     SignalBuffer[i]=BottomLine;
      if (MainBuffer[i]>=TopLine) 
               {SignalBufferUp[i]=TopLine;SignalBufferDn[i]=EMPTY_VALUE ;}
      if (MainBuffer[i]<=BottomLine) 
               {SignalBufferDn[i]=BottomLine;SignalBufferUp[i]=EMPTY_VALUE; }
      if (MainBuffer[i]>BottomLine && MainBuffer[i]<TopLine) 
               {SignalBufferUp[i]=EMPTY_VALUE; SignalBufferDn[i]=EMPTY_VALUE;}
   }
   return(0);
}

